#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

#include "calc.h"

double max(double, double);
double min(double, double);
double grind_value(char *name);

int yyparse();

NODEP mknode(opr,text,left,right)
char opr,text[];
NODEP left, right;
{
   NODEP node;
   node = (NODEP)malloc((unsigned)sizeof(NODE));
   if (node == NULL) {printf("Calculator: out of memory\n"); exit(0);}
   node->opr = opr;
   node->left = left;
   node->right = right;
   strncpy(node->text, text, 11);  
   return(node);
}

NODEP rmtree(node)
NODEP node;
{
  if (node != NULL) {
    rmtree(node->left);
    rmtree(node->right);
    free(node);
  }
  return(NULL);
}

double value(NODEP node)
{
  NODEP left,right;
  double v;
  if (node != NULL) {
    left = node->left;
    right = node->right;
    switch (node->opr) {
    case '0' : 
      return grind_value(node->text);
    case '1' : 
      sscanf(node->text,"%lf",&v); return v;
    case '+' : 
      return(value(left)+value(right));
    case '-' : 
      return(value(left)-value(right));
    case '*' :       
      return(value(left)*value(right));
    case '/' :       
      return(value(left)/value(right));
    case 'f' : 
      if (strcmp(node->text,"exp") == 0) 
	return exp(value(node->right));
      if (strcmp(node->text,"sin") == 0) 
	return sin(value(node->right));
      if (strcmp(node->text,"cos") == 0) 
	return cos(value(node->right));
      if (strcmp(node->text,"sqrt") == 0) 
	return sqrt(value(node->right));
      if (strcmp(node->text,"log") == 0) 
	return log(value(node->right));
      if (strcmp(node->text,"tan") == 0) 
	return tan(value(node->right));
      if (strcmp(node->text,"tanh") == 0) 
	return tanh(value(node->right));
    case 'g' : 
      if (strcmp(node->text,"pow") == 0) 
	return pow(value(left),value(right));
      if (strcmp(node->text,"max") == 0) 
	return max(value(left),value(right));
      if (strcmp(node->text,"min") == 0) 
	return min(value(left),value(right));
    default  :
      printf("\nUnknown operator: %s\n",node->text);
      return (double)0;
    }
  }
  printf("\nThis cannot happen (value)\n");
  return (double)0;
}

NODEP formula;
double value(NODEP);

int parse_error, semicolon, ipos;

char *line;

double calc(char txt[]) {
  double v;
  line = txt;
  /* strncpy(line, txt ,80); */
  semicolon = parse_error = ipos = 0;
  yyparse(); 
  if (parse_error) return (double)0; 
  v = value(formula);
  rmtree(formula);
  return v;
}
